﻿angular.module("umbraco")
    .controller("MediaProtect.Dashboard.LogviewerController",
    function ($scope, mediaprotectBackofficeResources, notificationsService) {

        $scope.pageNumber = 1;
        $scope.searchTerm = '';

        $scope.bindData = function () {
            mediaprotectBackofficeResources.getLogEntries($scope.searchTerm, $scope.pageNumber).then(function (res) {
                $scope.model = res.data;
                $scope.loaded = true;
            });
        };

        $scope.filter = function (q) {
            $scope.searchTerm = q;
            $scope.pageNumber = 1;
            $scope.bindData();
        }

        $scope.gotoPage = function (pageNumber) {
            $scope.pageNumber = pageNumber;
            $scope.bindData();
        }

        $scope.refresh = function () {
            $scope.pageNumber = 1;
            $scope.searchTerm = '';
            $scope.bindData();
        }

        $scope.clearLog = function () {
            if (confirm($scope.model.deleteLogMessage)) {
                mediaprotectBackofficeResources.clearLog().success(function (data) {
                    $scope.bindData();
                });
            }
        }

        $scope.exportData = function () {
            var a = document.createElement("a");
            document.body.appendChild(a);
            a.style = "display: none";
            mediaprotectBackofficeResources.exportData().success(function (data, status, headers, config) {

                var blob = new Blob([data], { type: "application/excel" });
                var objectUrl = URL.createObjectURL(blob);
                if (a.download !== undefined) {
                    a.href = objectUrl;
                    a.download = 'export.csv';
                    a.click();
                } else {
                    navigator.msSaveBlob(blob, 'export.xlsx');
                }
            }).error(function (data, status, headers, config) {
                //upload failed
                notificationsService.error('Error', 'Error exporting csv');
            });
        }


        //Initialize
        $scope.bindData();
    });