﻿angular.module("umbraco.resources")
    .factory("mediaprotectBackofficeResources", function ($http) {
        return {
            //ResourceService
            initializeResource: function () {
                return $http.get("backoffice/mediaprotect/mediaprotectlocalizationapi/initialize");
            },
            //Dialog resources
            initializeDialogResource: function (nodeId) {

                return $http.get('backoffice/mediaprotect/mediaprotectdialogapi/initialize', { params: { nodeId: nodeId} });
            },
            addRolesResource: function (rolesToAdd, roleInfo) {

                var data = {
                    "rolesToUpdate": rolesToAdd,
                    "current": roleInfo
                };

                return $http({
                    method: 'POST',
                    data: JSON.stringify(data),
                    url: 'backoffice/mediaprotect/mediaprotectdialogapi/AddRoles'
                });
            },
            removeRolesResource: function (rolesToRemove, roleInfo) {

                var data = {
                    "rolesToUpdate": rolesToRemove,
                    "current": roleInfo
                };

                return $http({
                    method: 'POST',
                    data: JSON.stringify(data),
                    url: 'backoffice/mediaprotect/mediaprotectdialogapi/RemoveRoles'
                });
            },
            save: function (dialogInfo) {

            return $http({
                method: 'POST',
                data: JSON.stringify(dialogInfo),
                url: 'backoffice/mediaprotect/mediaprotectdialogapi/save'
                });
            },
            validate: function (dialogInfo) {

                return $http({
                    method: 'POST',
                    data: JSON.stringify(dialogInfo),
                    url: 'backoffice/mediaprotect/mediaprotectdialogapi/validate'
                });
            },
            removeProtection: function (dialogInfo) {

                return $http({
                    method: 'POST',
                    data: JSON.stringify(dialogInfo),
                    url: 'backoffice/mediaprotect/mediaprotectdialogapi/removeprotection'
                });
            },
            rebuildIndex: function () {
                return $http.post("backoffice/mediaprotect/mediaprotectindexapi/rebuild");
            },
            reIndex: function (nodeId) {
                return $http({
                    method: 'POST',
                    params: { nodeId: nodeId} ,
                    url: 'backoffice/mediaprotect/mediaprotectindexapi/reindex'
                });
            },
            indexStatus: function () {
                return $http.get("backoffice/mediaprotect/mediaprotectindexapi/status");
            },
            getLogEntries: function (searchTerm, currentPage) {

                return $http.get('backoffice/mediaprotect/mediaprotectlogapi/getall', { params: { searchTerm: searchTerm, currentPage:currentPage } });
            },

            exportData: function () {
                return $http.get('backoffice/mediaprotect/mediaprotectlogapi/export');
            },
            clearLog: function () {

                return $http.post('backoffice/mediaprotect/mediaprotectlogapi/clearlog');
            }
        };
    });